'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _defineProperty = _interopDefault(require('@babel/runtime/helpers/defineProperty'));
var assembleReleasePlan = _interopDefault(require('@changesets/assemble-release-plan'));
var readChangesets = _interopDefault(require('@changesets/read'));
var getWorkspaces = _interopDefault(require('get-workspaces'));
var getDependentsgraph = _interopDefault(require('get-dependents-graph'));
var config = require('@changesets/config');
var pre = require('@changesets/pre');

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
async function getReleasePlan(cwd, sinceRef, passedConfig) {
  const workspaces = await getWorkspaces({
    cwd,
    tools: ["yarn", "bolt", "root"]
  });
  if (!workspaces) throw new Error("Could not resolve workspaces for current working directory");
  const preState = await pre.readPreState(cwd);
  const dependentsGraph = await getDependentsgraph({
    cwd
  });
  const readConfig = await config.read(cwd, workspaces);
  const config$1 = passedConfig ? _objectSpread({}, readConfig, {}, passedConfig) : readConfig;
  const changesets = await readChangesets(cwd, sinceRef);
  return assembleReleasePlan(changesets, workspaces, dependentsGraph, config$1, preState);
}

exports.default = getReleasePlan;
