"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var _defineProperty = _interopDefault(require("@babel/runtime/helpers/defineProperty")), assembleReleasePlan = _interopDefault(require("@changesets/assemble-release-plan")), readChangesets = _interopDefault(require("@changesets/read")), getWorkspaces = _interopDefault(require("get-workspaces")), getDependentsgraph = _interopDefault(require("get-dependents-graph")), config = require("@changesets/config"), pre = require("@changesets/pre");

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(source, !0).forEach(function(key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(source).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}

async function getReleasePlan(cwd, sinceRef, passedConfig) {
  const workspaces = await getWorkspaces({
    cwd: cwd,
    tools: [ "yarn", "bolt", "root" ]
  });
  if (!workspaces) throw new Error("Could not resolve workspaces for current working directory");
  const preState = await pre.readPreState(cwd), dependentsGraph = await getDependentsgraph({
    cwd: cwd
  }), readConfig = await config.read(cwd, workspaces), config$1 = passedConfig ? _objectSpread({}, readConfig, {}, passedConfig) : readConfig, changesets = await readChangesets(cwd, sinceRef);
  return assembleReleasePlan(changesets, workspaces, dependentsGraph, config$1, preState);
}

exports.default = getReleasePlan;
