import _defineProperty from '@babel/runtime/helpers/esm/defineProperty';
import assembleReleasePlan from '@changesets/assemble-release-plan';
import readChangesets from '@changesets/read';
import getWorkspaces from 'get-workspaces';
import getDependentsgraph from 'get-dependents-graph';
import { read } from '@changesets/config';
import { readPreState } from '@changesets/pre';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
async function getReleasePlan(cwd, sinceRef, passedConfig) {
  const workspaces = await getWorkspaces({
    cwd,
    tools: ["yarn", "bolt", "root"]
  });
  if (!workspaces) throw new Error("Could not resolve workspaces for current working directory");
  const preState = await readPreState(cwd);
  const dependentsGraph = await getDependentsgraph({
    cwd
  });
  const readConfig = await read(cwd, workspaces);
  const config = passedConfig ? _objectSpread({}, readConfig, {}, passedConfig) : readConfig;
  const changesets = await readChangesets(cwd, sinceRef);
  return assembleReleasePlan(changesets, workspaces, dependentsGraph, config, preState);
}

export default getReleasePlan;
